<html>
<head>
<title>
Cours de Compilation - FAQ (2)</title>
<link REL="StyleSheet" TYPE="text/css" HREF="Costyle.css">
<style>
em {color: #FFA0B0}
pre {color: #F0F0FF; font-family: courier; font-size:18pt;}
tt {color: #F0F0FF}
.vt {font-weight: bold; color: #70FF70}
.ib {font-weight: bold; font-style: italic}

</style>
</head>

<BODY BACKGROUND="" BGCOLOR="#002060" TEXT="#ffffa0" LINK="#80ff00" VLINK="#ff80c0" ALINK="#ff0000">
<P>

<center>
<h1>
Cours de Compilation - Foire Aux Questions (2)
</h1>
</center>
<p>

<!--
<a href="quest3.html"><span class="vt">FAQ, page 3.</span></a>
-->
<p>

<dl>
<dt>
<span class=vt>David Villy :</span> 
Voici 3 affirmations pour le devoir ; dîtes-moi, s'il vous plaît, si je
me trompe :
<p>

<ol>
<li> Des 3 déclarations "type", "newtype", et "instance Monad" vues en
TD pour le parseur monadique UParseur, il ne faut en choisir qu'une,
préférablement la troisième, n'est-ce pas ?
<p>

<li> Le parseur construisant la "boîte" doit se décomposer en 3
sous-parseurs : lexical, syntaxique et sémantique, n'est-ce pas ?
<p>

<li> Enfin la déclaration :
<pre>
data lexeme = Lpar | Rpar | Id String | Intg Int | Op String | ...
</pre>
ne doit pas apparaître dans le programme, mais seulement :
<pre>
   Lpar = blanks >> literal '(' >> return Lpar
   Id = blanks >> mot >>= \m -> return (Id m)
   ...
   lex = Lpar # Rpar # Ident # ...
</pre>
<p>
</ol>
<p>
<hr>
<p>


<dd>
Je crains que votre question ne montre une certaine confusion.
C'est un avertissement fort pour moi...
<p>
<ol>
<li> Les trois constructions syntaxiques que vous mentionnés sont <em>très différentes</em>,
jouent des rôles incomparables.
<ul>
<li> <tt>type</tt> n'est qu'une abréviation. Au lieu d'opérer avec, disons, <tt>[Char]</tt>
on définit <tt>type String=[Char]</tt>, et c'est tout. Si on a besoin d'objets fonctionnels,
on déclare souvent <tt>type Fnc a = a -&gt a</tt>, 
éventuellement <tt>type Fint = Integer -&gt; Integer</tt> betc., mais - je répète - c'est une <b>notation</b>, presque toujours redondante. lle facilite la lecture du programme, elle peut
être utilisée pour spécifier le fait qu'on renonce de l'inférence automatique de types, et on
force un type restreint, par exemple
<pre>
f :: Fint
f n = n*(abs n)
</pre>
ce qui définit <tt>f</tt> comme une fonction entière, même si sans cette déclaration elle aurait pu
être également flottante.

<p>
<li> <tt> newtype</tt> et <tt>data</tt> définissent des <em>nouveaux types</em>. La construction
<tt>data NType = ...</tt> (ou <tt>NType a = ... </tt>) est une spécification d'une structure
de donnés, de type énuméré, séquence (liste), arbre, etc. C'est comme struct ou/et union en "C".
<p>

La différence entre <tt>newtype</tt> et <tt>data</tt> est que <tt>data</tt> est <em>vraiment</em>
un type nouveau, complètement différent de tout vu jusqu'à ce moment, avec les nouveaux
champs, alternatives, etc. Par contre, <tt>newtype</tt> ajoute une balise identifiante à un
type existant, et avec cette balise qui existe uniquement pendant la compilation, les objets sont considérés différents des autres. Cependant <em>l'implantation</em> peut rester identique que
pour un autre type, par exemple nous pouvons définir <tt>newtype Pile a = P [a]</tt>. Les piles
seront les listes, mais il faut les écrire comme, disons <tt>P (a:b:aq)</tt>, et le programme
réfusera de confondre les piles et autres listes.
<p>

<li> La déclaration d'instance prévoit que le type en question <em>possède quelques propriétés</em>,
qu'un certain nombre de fonctions y est présente. Ainsi les types numériques admettent les opérateurs <tt>(+), (-), (*), negate</tt>, etc., les objets monadiques (n'importe quelle monade) peuvent utiliser les fontions <tt>return</tt> et <tt>(&gt;&gt=)</tt>, plusieurs objets très différents (mais pas tous !) peuvent être comparés avec <tt>(==)</tt>, etc. C'est ça, la déclaration d'instance.

</ul>
<p>
Pour un programme complet il vous faudra définir le type, et préciser les instances, ce n'est pas une question de choix. Lisez SVP la documentation du langage Haskell, c'est le dernier moment. Durant l'examen l'ignorance des éléments fondamentaux de ce langage ne sera pas une circonstance atténuante...
<p>

<p>
<hr>
<p>


<li> Non ! Le parseur "sémantique" est integré avec le syntaxique, c'est ce que nous avons fait
jusqu'à présent. Le scanneur lexical doit être séparé, mais ceci n'est pas une exigence
formelle. Vous pouvez construire un seul type de parseur qui agit sur les chaînes de caractères
et qui produit les boîtes. La séparation des lexèmes est pour vous rendre la vie plus facile.
<p>

Par contre, il existe la troisième étape - l'affichage des boîtes. On peut, si on est un peu
fou, essayer de structurer cette fonction comme un parseur très spécial, mais c'est
complètement inutile. Ceci doit être une fonction récursive qui transforme une boîte en
chaîne de caractères avec les espaces, sauts de ligne, etc.

<p>
<hr>
<p>


<li> Non, non, et non !! Tout est mauvais.
<p>

D'abord, les identificateurs qui commencent par des majuscules sont des <em>constantes littérales</em>, les balises, les définitions de types, etc. Les <i>objets</i>, p. ex.
les fonctions, les variables, etc. commencent par les lettres minuscules.
<p>
Ensuite, si vous voulez utiliser les données composites, il faut les déclarer. Voulez vous
les constantes de type Lexème? Alors définissez
<pre>
data Lexème = ... | Lpar | ...
</pre>
(bien sûr, vous pouvez récupérer les définitions du cours/TD.)
<p>
ensuite vous précisez le <em>parseur</em>, c'est-à-dire la procédure de reconnaissance,
avec la sémantique attachée, par exemple
<pre>
lpar = blanks >> literal '(' >> return Lpar
</pre>
Si vous confondez <tt>Lpar</tt> avec <tt>lpar</tt>, votre programme ne se compilera pas.
<p>

</ol>
<p>

<p>
<hr>
<p>

<dt>
<span class=vt>Antoine Chuquet et Jean-Marc Auryy :</span> 
Quelques questions au sujet du devoir de compilation :
<p>

<ol>
<li> Que doit on vous rendre (fichier haskell, code sur papier,
documentation,  ...) ?<p>

<li> L'omission du signe * n'est-il valable que pour 2 identificateurs
successifs ?
<blockquote>
ex : alpha beta -> alpha*beta, <br>
mais est-il légal d'écrire (2+3) (2-5) -> (2+3)*(2-5) ?
</blockquote>
<p>

<li> Peut-on laisser des calculs en attente lors de l'analyse
syntaxique ?
<blockquote>
ex : Avec une grammaire de la forme : <br>
<b>expr ::= '{' expr '//' expr '}' expr1</b>
</blockquote><p>

<li> Quand vous ecrivez "le parseur doit reconnaître le minimum de
fautes comme a+ ou x/*g", que faut-il mettre en oeuvre pour la reconnaissance 
des erreurs ?
</ol>
<p>

<p><hr width=25% align=center>
<p>

<dd> 
Voici les réponses :
<ol>
<li> Le <em>rapport</em> avec:
<ol type="A">
<li> Description succinte de la stratégie du parsing, des structures de
   données utilisées, de l'algorithme d'affichage, etc.
<li> Listing du programme avec un minimum de commentaires.
<li> Exemples (riches, au moins 5 différents) avec
 <ol type="i">
 <li> Code source
 <li> Affichage 2-dim.
 </ol>
<li> Exemple montrant le traitement des erreurs syntaxiques.
</ol>
<p>

<li> <em>BONNE QUESTION !</em> <br>
Je pense que l'étoile entre parenthèses est redondante et peut disparaître.
Par contre, entre constantes numériques : 23*465 -=> 23 465 on doit la
laisser, sinon vous voyez ce qu'il y a à voir...
<p>

<li> Je ne comprends pas cette question. Pas du tout.
<p>
<li> Il faut tout simplement écrire le parseur de façon à ce qu'il puisse identifier
la faute et écrire le diagnostic correspondant. Le "parseur principal",
"expression" (ou qqch. comme ça) ne doit pas échouer ; l'échec dans ce
contexte signifie l'erreur, et c'est tout, il serait tout simplement utile
de signaler dans quel endroit la faute a été découverte.
<p>

Ceci serait plus facile si le parseur construisait en parallèle avec le résultat
une chaîne - echo de la source.
</ol>




</dl>
<p>

<p>
<hr>
<p>

<p align=right>
<a href="index.html"> 
Retour à la page Maît-compil &nbsp; 
<img src="../icons/gb_lcarb.gif" border=0 align=absmiddle></a>
<p>
<hr><p>

</body>
</html>
